<template>
  <div>
    <base-dialog
      :show="showDialogConfirmation"
      title="Confirm Deletion"
      @close="closeDialog"
    >
      <template #default>
        <p>
          Are you sure you want to delete invoice {{ invoice.id }}? This action
          cannot be undone.
        </p>
      </template>
      <template #actions>
        <div class="flex">
          <base-button mode="quaternary" @click="closeDialog"
            >Cancel</base-button
          >
          <base-button mode="danger" @click="deleteInvoice">Delete</base-button>
        </div>
      </template>
    </base-dialog>
    <div class="container grid">
      <base-button link to="/" class="flex link-back">
        <img src="@/assets/icon-arrow-left.svg" />
        Go back
      </base-button>
      <base-card class="invoice-header">
        <div class="flex invoice-header__status">
          <p>Status</p>
          <base-status :type="status" :title="status"></base-status>
        </div>
        <div class="flex invoice-header__controls">
          <base-button @click="editInvoice" mode="secondary">Edit</base-button>
          <base-button mode="danger" @click="openDialog">Delete</base-button>
          <base-button
            v-if="status != 'paid'"
            mode="primary"
            @click="changeStatus('paid')"
            >Mark As Paid</base-button
          >
        </div>
      </base-card>
      <base-card class="grid grid--detail">
        <div class="description">
          <h3><span class="text-neutral-400">#</span>{{ invoice.id }}</h3>
          <p class="text-body-a">{{ invoice.description }}</p>
        </div>
        <div class="sender-address text-body-a">
          <p>{{ invoice.senderAddress.street }}</p>
          <p>{{ invoice.senderAddress.city }}</p>
          <p>{{ invoice.senderAddress.postCode }}</p>
          <p>{{ invoice.senderAddress.country }}</p>
        </div>
        <div class="invoice-date">
          <p class="text-body-a">Invoice Date</p>
          <p class="fw-700">{{ createdAt }}</p>
        </div>
        <div class="payment-due">
          <p class="text-body-a">Payment Due</p>
          <p class="fw-700">{{ paymentDue }}</p>
        </div>
        <div class="client-email">
          <p class="text-body-a">Sent to</p>
          <p class="fw-700">{{ invoice.clientEmail }}</p>
        </div>
        <div class="client-address">
          <p class="text-body-a">Bill to</p>
          <p class="fw-700">{{ invoice.clientName }}</p>
          <div class="text-body-a">
            <p>{{ invoice.clientAddress.street }}</p>
            <p>{{ invoice.clientAddress.city }}</p>
            <p>{{ invoice.clientAddress.postCode }}</p>
            <p>{{ invoice.clientAddress.country }}</p>
          </div>
        </div>
        <base-card class="items">
          <table>
            <thead>
              <tr>
                <th>Item Name</th>
                <th>QTY.</th>
                <th>Price</th>
                <th>Total</th>
              </tr>
            </thead>
            <tbody>
              <tr v-for="item in invoice.items" :key="item.id">
                <td>{{ item.name }}</td>
                <td>{{ item.quantity }}</td>
                <td>£{{ item.price }}</td>
                <td>£{{ item.total }}</td>
              </tr>
            </tbody>
            <tfoot>
              <tr class="text-neutral-100">
                <td>Amount Due</td>
                <td></td>
                <td></td>
                <td>{{ total }}</td>
              </tr>
            </tfoot>
          </table>
        </base-card>
      </base-card>
    </div>
    <base-card class="flex invoice-footer">
      <div class="flex invoice-footer__controls">
        <base-button mode="secondary" @click="editInvoice">Edit</base-button>
        <base-button mode="danger" @click="openDialog">Delete</base-button>
        <base-button
          v-if="status != 'paid'"
          mode="primary"
          @click="changeStatus('paid')"
          >Mark As Paid</base-button
        >
      </div>
    </base-card>
    <transition name="scale-slide">
      <invoice-form
        v-if="showNewInoviceForm"
        :invoice="invoice"
        @discard="discard"
        @save-invoice="saveInvoice"
        class="new-invoice-form"
      ></invoice-form>
    </transition>
  </div>
</template>

<script>
import InvoiceForm from "@/components/invoices/InvoiceForm.vue";

export default {
  components: {
    InvoiceForm,
  },
  props: ["id"],
  title() {
    return `Invoice | #${this.id}`;
  },
  data() {
    return {
      showNewInoviceForm: false,
      showDialogConfirmation: false,
      isLoading: false,
    };
  },

  computed: {
    invoice() {
      return this.$store.getters["invoices/invoice"];
    },
    status() {
      return this.invoice.status;
    },

    createdAt() {
      const date = new Date(this.invoice.createdAt);
      return date.toDateString();
    },
    paymentDue() {
      const date = new Date(this.invoice.paymentDue);
      return date.toDateString();
    },
    total() {
      return "£" + this.invoice.total;
    },
  },
  created() {
    this.loadInvoice();
  },
  methods: {
    closeDialog() {
      this.showDialogConfirmation = false;
    },
    openDialog() {
      this.showDialogConfirmation = true;
    },
    async deleteInvoice() {
      const id = this.invoice.id;
      this.isLoading = true;
      try {
        await this.$store.dispatch("invoices/deleteInvoice", id);
      } catch (error) {
        this.error = error.message || "Something went wrong!";
      }
      this.isLoading = false;
      this.$router.replace("/");
    },
    editInvoice() {
      this.showNewInoviceForm = true;
    },
    discard() {
      this.showNewInoviceForm = false;
    },
    async saveInvoice(data) {
      this.discard();
      this.isLoading = true;
      try {
        await this.$store.dispatch("invoices/editInvoice", data);
      } catch (error) {
        this.error = error.message || "Something went wrong!";
      }
      this.isLoading = false;
    },
    async loadInvoice() {
      this.isLoading = true;
      try {
        await this.$store.dispatch("invoices/loadInvoice", this.id);
      } catch (error) {
        this.error = error.message || "Something went wrong!";
      }
      this.isLoading = false;
    },
    async changeStatus(status) {
      this.isLoading = true;
      try {
        await this.$store.dispatch("invoices/changeStatus", status);
      } catch (error) {
        this.error = error.message || "Something went wrong!";
      }
      this.isLoading = false;
    },
  },
};
</script>

<style scoped>
.invoice-header__status {
  justify-content: space-between;
}
.invoice-header__controls {
  display: none;
}
.invoice-footer {
  justify-content: flex-end;
}
@media (min-width: 56.25em) {
  .invoice-header {
    display: flex;
    justify-content: space-between;
  }
  .invoice-header__controls {
    display: flex;
  }
  .invoice-footer {
    display: none;
  }
}
.grid--detail {
  grid-template-areas:
    "description    ..."
    "sender-address ..."
    "invoice-date   client-address"
    "payment-due    client-address"
    "client-email   ..."
    "items          items";
}

.description {
  grid-area: description;
}

.sender-address {
  grid-area: sender-address;
}
.invoice-date {
  grid-area: invoice-date;
}
.payment-due {
  grid-area: payment-due;
}
.client-email {
  grid-area: client-email;
}
.client-address {
  grid-area: client-address;
}
@media (min-width: 56.25em) {
  .grid--detail {
    grid-template-areas:
      "description  ... ... sender-address"
      "invoice-date client-address client-email client-email"
      "payment-due  client-address .... ..."
      "items        items          items  items";
    column-gap: 2rem;
  }
  .sender-address {
    justify-self: end;
  }
}
.items {
  grid-area: items;
  background: hsl(var(--clr-invoice-table-bg));
  padding: 0;
  overflow: hidden;
}
table {
  width: 100%;
  border-spacing: 0px;
}
thead th,
tbody td,
tfoot td {
  padding: 1rem;
  font-weight: var(--fw-700);
}

thead,
td:nth-child(2),
td:nth-child(3) {
  display: none;
}
th:nth-child(1),
td:nth-child(1) {
  text-align: start;
}
th:nth-child(2),
th:nth-child(3),
td:nth-child(2),
td:nth-child(3) {
  text-align: center;
}
th:nth-child(4),
td:nth-child(4) {
  text-align: end;
}
tfoot {
  background: hsl(var(--clr-invoice-table-footer-bg));
}

@media (min-width: 56.25em) {
  thead {
    display: table-header-group;
    color: hsl(var(--clr-text-body-a));
  }
  td:nth-child(2),
  td:nth-child(3) {
    display: table-cell;
  }
}
.link-back {
  --gap: 0.5rem;
  align-items: baseline;
}
.new-invoice-form {
  position: fixed;
  top: 5rem;
  left: 0px;
  z-index: 10;
  background: hsl(var(--clr-form-bg));
}
@media (min-width: 56.25em) {
  .new-invoice-form {
    top: 0;
    left: 6rem;
  }
}
.scale-slide-enter-active,
.scale-slide-leave-active {
  transition: all 0.85s ease;
}
.scale-slide-leave-to,
.scale-slide-enter-from {
  left: -100%;
}
@media (min-width: 56.25em) {
  .scale-slide-leave-from,
  .scale-slide-enter-to {
    left: 6rem;
  }
}
</style>
